<?php

/*
Debugger for Page Manager Plugin for MyBB
Copyright (C) 2010 Sebastian Wunderlich

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

if(!defined('IN_MYBB'))
{
	die();
}

function pagemanagerdebugger_info()
{
	if(!headers_sent())
	{
		pagemanagerdebugger();
	}
	return array
	(
		'name'=>'Page Manager Debugger',
		'description'=>'Please activate this plugin to get some debug output of Page Manager.',
		'author'=>'Sebastian Wunderlich',
		'version'=>'1.0',
		'compatibility'=>'14*,16*',
	);
}

function pagemanagerdebugger()
{
	global $mybb,$db,$lang,$plugins_cache;
	$plugins='';
	if(is_array($plugins_cache)&&is_array($plugins_cache['active']))
	{
		foreach($plugins_cache['active'] as $active)
		{
			$plugins.=$active.', ';
		}
		if($plugins)
		{
			$plugins='
		<plugins><![CDATA['.trim($plugins,', ').']]></plugins>';
		}
	}
	$pagemanager='';
	$file='../inc/plugins/pagemanager.php';
	if(file_exists($file))
	{
		$pagemanager.='
		<md5><![CDATA['.md5_file($file).']]></md5>';
		if(is_array($plugins_cache)&&is_array($plugins_cache['active'])&&$plugins_cache['active']['pagemanager'])
		{
			require_once $file;
			$info=pagemanager_info();
			foreach($info as $property=>$value)
			{
				$pagemanager.='
		<'.$property.'><![CDATA['.$value.']]></'.$property.'>';
			}
		}
		$pagemanager='
	<pagemanager>'.$pagemanager.'
	</pagemanager>';
	}
	$table='';
	if($db->table_exists('pages'))
	{
		$table='
	<table>
		<create><![CDATA['.$db->show_create_table('pages').']]></create>
	</table>';
	}
	$xml='<?xml version="1.0" encoding="'.$lang->settings['charset'].'"?>
<pagemanager_debug>
	<server>
		<php><![CDATA['.phpversion().']]></php>
		<database><![CDATA['.$db->short_title.' '.$db->get_version().']]></database>
	</server>
	<mybb>
		<version><![CDATA['.$mybb->version.']]></version>'.$plugins.'
	</mybb>'.$pagemanager.$table.'
</pagemanager_debug>';
	header('Content-Disposition: attachment; filename=pagemanager_debug.xml');
	header('Content-Type: application/xhtml+xml');
	header('Content-Length: '.strlen($xml));
	header('Pragma: no-cache');
	header('Expires: 0');
	echo $xml;
	exit();
}

?>